//********************************************************************;
//*                                                                  *;
//*  Intel(R) Confidential                                           *;
//*                                                                  *;
//*  TXTINFO64   Tool                                                *;
//*                                                                  *;
//*  Copyright (c) 2009 Intel Corp.                                  *;
//*                                                                  *;
//*  This code has been developed by Intel Corporation.              *;
//*  Licensee has Intel's permission to incorporate this source code *;
//*  into their product, royalty free.  This source code may NOT be  *;
//*  redistributed to anyone without Intel's written permission.     *;
//*                                                                  *;
//*  Intel specifically disclaims all warranties, express or         *;
//*  implied, and all liability, including consequential and other   *;
//*  indirect damages, for the use of this code, including liability *;
//*  for infringement of any proprietary rights, and including the   *;
//*  warranties of merchantability and fitness for a particular      *;
//*  purpose.  Intel does not assume any responsibility for any      *;
//*  errors which may appear in this code nor any responsibility to  *;
//*  update it.                                                      *;
//*                                                                  *;
//********************************************************************;

#ifndef _TPM_STATUS
#define _TPM_STATUS
#include "TPMInfo.h"

UINT32 g_DebugMask;


#define		TPM_FACT_PROV_TOOL_MAJOR_VERSION				L"1"
#define		TPM_FACT_PROV_TOOL_MINOR_VERSION				L".0"
#define		TPM_FACT_PROV_TOOL_NAME						L"INTELTPMFACTORYPROVISIONINGTOOL"

/* Error codes that are communicated back to the environment.
*  Upper bit should not be set otherwise the EFI Shell environment launching our app
*  may have an issue
*	All errors have bit 30 set
*	All warnings have bit 30 cleared
*/

//typedef UINT32 TPMTOOL_STATUS;

#define TPMTOOL_SUCCESS								0

#define	TPMTOOL_ERRORCODE_MEMORYRESOURCES			0x40000001 /* error */
#define	TPMTOOL_ERRORCODE_TPMWRITEFAILED			0x40000002
#define	TPMTOOL_WARNING_NOLOCKOPTIONPROVIDED(x)		((x) = (x) | 0x10000000) /* flip bit 28 to indicate no lock option not provided */
#define	TPMTOOL_ERRORCODE_ERRORINCFGFILE(x)			((x) = (x) | 0x20000000) /* flip bit 28 to indicate no lock option not provided */
#define	TPMTOOL_ERRORCODE_NOTPMPRESENT				0x40000004
#define	TPMTOOL_ERRORCODE_TPMREADFAILED				0x40000005

#define	TPMTOOL_ERRORCODE_PSINDEXNOTPRESENTINTPM	0x40000006
#define	TPMTOOL_ERRORCODE_PSINDEXNOTCORRECTSIZE		0x40000007
#define	TPMTOOL_ERRORCODE_PSINDEXPOLICYVERSIONINCORRECT		0x40000008
#define	TPMTOOL_ERRORCODE_PSINDEXPOLICYTYPEINCORRECT		0x40000009
#define	TPMTOOL_ERRORCODE_PSINDEXPOLICYNOTWRITEPROTECTED	0x4000000A

#define	TPMTOOL_ERRORCODE_AUXINDEXNOTPRESENTINTPM	0x40000010
#define	TPMTOOL_ERRORCODE_AUXINDEXNOTCORRECTSIZE	0x40000011
#define	TPMTOOL_ERRORCODE_AUXINDEX2AND3				0x40000012
#define	TPMTOOL_ERRORCODE_AUXINDEXWRONG				0x40000013

#define	TPMTOOL_ERRORCODE_TPMNVRAMNOTPRESENT		0x40000020
#define	TPMTOOL_ERRORCODE_TPMNVRAMNOTLOCKED			0x40000021
#define	TPMTOOL_ERRORCODE_TPMNVRAMNOTCORRECTSIZE	0x40000022

#define	TPMTOOL_ERRORCODE_UNKNOWNERROR				0x40000100

#define	TPMTOOL_ERRORCODE_CFGFILENOTPRESENT			0x40000200

typedef	struct		_TPMFACT_NVLOCKED_STATE_QUERY_BLOCK_t
{
	void		*pAuxDefParsedFileDataBuffer; /* IN */
	UINT32		auxDefParseFileDataBufferLength; /* IN */
	TPM_ENCAUTH	auxDefEncAuthData;
	BOOLEAN		bAuxIndexPresentInTPM;
	BOOLEAN		bAuxIndexSizedCorrectly;

	void		*pPSDefParsedFileDataBuffer;
	UINT32		psDefParsedFileDataBufferLength; /* in bytes */
	TPM_ENCAUTH	psDefEncAuthData;
	BOOLEAN		bPSIndexPresent;
	BOOLEAN		bPSIndexSizedCorrectly;
	
	//These two checks are depricated since we need to check the whole data block for changes.
	//BOOLEAN		PSIndexDataCorrectVersion;
	//BOOLEAN		PSIndexDataHasCorrectPolicyType;
	
	BOOLEAN		PSIndexDataCorrect;
	BOOLEAN		bPSPolicyWriteProtected;

	void		*pPSPolicyDataBuffer;
	UINT32		PSPolicyDataBufferLength;

	/* if set, the internal routines will lock NVRAM before exiting. */
	BOOLEAN		bLockTPMNVRAM;

	/* This is a status variable to indicate if TPM is locked */
	BOOLEAN		bTPMNVLocked;
	BOOLEAN		bTPMNVRamPresent;
	BOOLEAN		bTPMNVRamCorrectSize;
	/* a non-zero value means something happened (Write errors)	*/
	UINT32		ErrorCode;
} TPMFACT_NVLOCKED_STATE_QUERY_BLOCK_t;

//CHAR8 *mystrtok(CHAR16* string, const CHAR16 *delim);

#endif //_TPM_FACT_PROV